config/routes.rb
Spree::Core::Engine.routes.draw do
  # Add your extension routes here
  namespace :admin do
    resources :favorite_products, only: [:index, :destroy] do
      get :users, on: :member, to: 'products#favorite_users'
    end

    resources :favorite_variants, only: :index

    resources :products do
      get :favorite_users, on: :member
    end

    resources :users do
      get :favorite_products, on: :member
    end
  end

  resources :favorite_products, only: [:index, :create, :destroy] do
    get :get_favoritable_value, on: :member
  end
end

app/models/spree/app_configuration_decorator.rb
Spree::AppConfiguration.class_eval do
  preference :favorite_products_per_page, :integer, default: 10
  preference :favorite_users_per_page, :integer, default: 10
end

app/models/spree/favorite.rb
module Spree
  class Favorite < ActiveRecord::Base
    with_options required: true do
      belongs_to :favoritable, polymorphic: true, counter_cache: :favorite_users_count
      belongs_to :user
    end

    validates :user_id, uniqueness: { scope: [:favoritable_id, :favoritable_type], message: Spree.t(:duplicate_favorite), allow_blank: true }
  end
end

app/models/spree/product_decorator.rb
Spree::Product.class_eval do
  has_many :favorites, as: :favoritable, dependent: :destroy
  has_many :favorite_users, through: :favorites, class_name: 'Spree::User', source: :user

  scope :favorite, -> { joins(:favorites).distinct }
  scope :order_by_favorite_users_count, ->(asc = false) { order(favorite_users_count: "#{asc ? 'asc' : 'desc'}") }

end

app/models/spree/user_decorator.rb
Spree::User.class_eval do
  has_many :favorites, dependent: :destroy
  has_many :favorite_products, through: :favorites, source: :favoritable, source_type: 'Spree::Product'
  has_many :favorite_variants, through: :favorites, source: :favoritable, source_type: 'Spree::Variant'

  def has_favorite_product?(product_id)
    favorites.exists? favoritable_id: product_id, favoritable_type: 'Spree::Product'
  end

  def has_favorite_variant?(variant_id)
    favorites.exists? favoritable_id: variant_id, favoritable_type: 'Spree::Variant'
  end
end

app/models/spree/variant_decorator.rb
Spree::Variant.class_eval do
  has_many :favorites, as: :favoritable, dependent: :destroy
  has_many :favorite_users, through: :favorites, class_name: 'Spree::User', source: :user

  scope :favorite, -> { joins(:favorites).distinct }
  scope :order_by_favorite_users_count, ->(asc = false) { order(favorite_users_count: "#{asc ? 'asc' : 'desc'}") }
end

app/controllers/spree/admin/favorite_products_controller.rb
module Spree
  module Admin
    class FavoriteProductsController < Spree::Admin::BaseController

      def index
        @search = Spree::Product.favorite.search(params[:q])
        @favorite_products = @search.result.includes(master: :images).joins(:master).order_by_favorite_users_count(sort_in_ascending_users_count?).page(params[:page]).per(Spree::Config.favorite_products_per_page)
      end

      def destroy
        @favorite = Spree::Favorite.find_by(id: params[:id])
        if @favorite.destroy
          flash[:success] = flash_message_for(@favorite, :successfully_removed)
        else
          flash[:error] = @favorite.errors.full_messages.join(', ')
        end

        respond_with(@favorite) do |format|
          format.html { redirect_to location_after_destroy }
          format.js   { render_js_for_destroy }
        end
      end

      private
        def sort_in_ascending_users_count?
          params[:q] && params[:q][:s] == 'favorite_users_count asc'
        end
    end
  end
end

app/controllers/spree/admin/favorite_variants_controller.rb
module Spree
  module Admin
    class FavoriteVariantsController < Spree::Admin::BaseController

      def index
        @search = Spree::Variant.favorite.search(params[:q])
        @favorite_variants = @search.result.includes(:product, :images).joins(:product).order_by_favorite_users_count(sort_in_ascending_users_count?).page(params[:page]).per(Spree::Config.favorite_products_per_page)
      end

      private
        def sort_in_ascending_users_count?
          params[:q] && params[:q][:s] == 'favorite_users_count asc'
        end
    end
  end
end

app/controllers/spree/admin/products_controller_decorator.rb
Spree::Admin::ProductsController.class_eval do

  before_action :set_variant, only: :favorite_users

  def favorite_users
    if params[:type] == 'variant'
      set_favorite_variant_users(@variant.id)
    elsif params[:type] == 'product'
      set_favorite_product_users
    else
      set_favorite_product_users
      set_favorite_variant_users(@product.variants.pluck(:id))
    end
  end

  private

    def set_variant
      return if params[:type] != 'variant'

      @variant = Spree::Variant.find_by(id: params[:item_id])
      unless @variant.present?
        flash[:error] = Spree.t(:variant_does_not_exist)
        redirect_to admin_products_path
      end
    end

    def set_favorite_product_users
      @favorite_product_users = @product.favorite_users.page(params[:favorite_product_users_page]).per(Spree::Config.favorite_users_per_page)
    end

    def set_favorite_variant_users(id)
      return unless id.present?

      @favorite_variant_users = Spree::User.joins(:favorite_variants).
                           where(spree_favorites: { favoritable_id: id, favoritable_type: 'Spree::Variant' }).
                           select('spree_users.*, spree_favorites.favoritable_id').page(params[:favorite_variant_users_page]).per(Spree::Config.favorite_users_per_page)
    end

end

app/controllers/spree/admin/users_controller_decorator.rb
Spree::Admin::UsersController.class_eval do
  def favorite_products
    @favorite_products = @user.favorite_products
    @favorite_variants = @user.favorite_variants
  end
end

app/controllers/spree/favorite_products_controller.rb
module Spree
  class FavoriteProductsController < Spree::StoreController

    before_action :store_favorite_product_preference, only: :create
    before_action :authenticate_spree_user!, except: :get_favoritable_value
    before_action :find_favorite_product, only: :destroy

    def index
      @favorite_products = spree_current_user.favorite_products
      @favorite_variants = spree_current_user.favorite_variants
    end

    def create
      favorite = spree_current_user.favorites.new(favoritable_params)
      if @success = favorite.save
        @message = Spree.t(:success, scope: [:favorite_products, :create])
      else
        @message = favorite.errors.full_messages.to_sentence
      end
      respond_to do |format|
        format.js
      end
    end

    def destroy
      @success = @favorite.destroy
    end

    # returns whether user has favorited a product/variant or not
    def get_favoritable_value
      if spree_current_user.present?
        @favorite = spree_current_user.favorites.where(favoritable_params).first
      end

      respond_to do |format|
        format.js
      end
    end

    private
      def find_favorite_product
        @favorite = spree_current_user.favorites.where(favoritable_params).first

        unless @favorite.present?
          respond_to do |format|
            format.html { redirect_to products_path, notice: Spree.t(:product_not_found) }
            format.js do
              render :not_found, status: 422 and return
            end
          end
        end
      end

      def store_favorite_product_preference
        unless spree_current_user
          if params[:type] == 'Spree::Product'
            session[:spree_user_return_to] = product_path(id: params[:id], favorite_product_id: params[:id], type: 'product')
          else
            variant = Spree::Variant.find_by(id: params[:id])
            session[:spree_user_return_to] = product_path(id: variant.product.id, favorite_product_id: params[:id], type: 'variant')
          end
          redirect_to login_path, notice: Spree.t(:login_to_add_favorite)
        end
      end

      def favoritable_params
        {
          favoritable_id: params[:id],
          favoritable_type: params[:type]
        }
      end
  end
end

app/views/spree/admin/favorite_products/_favorited_by_users.html.erb
<% users.each do |user| %>
  <tr id="<%= spree_dom_id user %>" data-hook="admin_users_index_rows">
    <td class='user_email'><%=link_to user.email, edit_admin_user_url(user) %></td>
    <% if type == 'variant' %>
      <td>
        <% variant = Spree::Variant.find_by(id: user.favoritable_id) %>
        <%= variant.sku %>
      </td>
      <td data-hook="admin_users_index_row_actions" class="actions actions-2 text-right">
        <%= link_to_edit user,{ no_text: true, url: edit_admin_user_path(id: user) } %>
        <%= link_to_delete user, no_text: true, url: admin_favorite_product_path(id: user.favorites.where(favoritable_id: variant.id, favoritable_type: 'Spree::Variant').first) %>
      </td>
    <% else %>
      <td> <%= @product.sku %> </td>
      <td data-hook="admin_users_index_row_actions" class="actions actions-2 text-right">
        <%= link_to_edit user,{ no_text: true, url: edit_admin_user_path(id: user) } %>
        <%= link_to_delete user, no_text: true, url: admin_favorite_product_path(id: user.favorites.where(favoritable_id: @product.id, favoritable_type: 'Spree::Product').first) %>
      </td>
    <% end %>
  </tr>
<% end %>

app/views/spree/admin/favorite_products/_table.html.erb
<table class="table table-striped" id="listing_favorite_products_users">
  <thead>
    <tr data-hook="admin_products_index_headers">
      <th><%= Spree.t(:email) %></th>
      <th><%= Spree.t(:sku) %></th>
      <th data-hook="admin_users_index_header_actions" class="actions text-right"> <%= Spree.t(:action) %></th>
    </tr>
    <%= render partial: 'spree/admin/favorite_products/favorited_by_users', locals: { users: users, type: type } %>
  </thead>
  <tbody>
  </tbody>
</table>

app/views/spree/admin/favorite_products/_users.html.erb
<% if !@favorite_product_users.present? && !@favorite_variant_users %>
  <div class="no-objects-found">
    <%= Spree.t(:no_results) %>
  </div>
<% end %>

<% if @favorite_product_users.present? %>
  <%= paginate @favorite_product_users, param_name: 'favorite_product_users_page' %>
  <%= render partial: 'spree/admin/favorite_products/table', locals: { users: @favorite_product_users, type: 'product' } %>
<% end %>

<% if @favorite_variant_users.present? %>
  <%= paginate @favorite_variant_users, param_name: 'favorite_variant_users_page' %>
  <%= render partial: 'spree/admin/favorite_products/table', locals: { users: @favorite_variant_users, type: 'variant' } %>
<% end %>

app/views/spree/admin/favorite_products/index.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:listing_favorite_products) %>
<% end %>

<%= paginate @favorite_products %>

<% if @favorite_products.any? %>
  <table class="table table-striped" id="listing_products">
    <thead>
      <tr data-hook="admin_products_index_headers">
        <th><%= Spree.t(:sku) %></th>
        <th><%= Spree.t(:image) %></th>
        <th><%= sort_link @search, :name, Spree.t(:name) %></th>
        <th class="text-right"><%= sort_link @search, 'favorite_users_count', Spree.t(:favorite_users) %></th>
      </tr>
    </thead>
    <tbody>
      <% @favorite_products.each do |product| %>
          <tr data-hook="admin_products_index_rows">
            <td ><%= product.sku rescue '' %></td>
            <td ><%= mini_image(product) %></td>
            <td><%= link_to product.try(:name), edit_admin_product_path(product) %></td>
            <td class="text-right">
              <%= link_to product.favorite_users.count, users_admin_favorite_product_path(id: product.id, type: 'product') %>
            </td>
          </tr>
      <% end %>
    </tbody>
  </table>
<% else %>
  <div class="no-objects-found">
    <%= Spree.t(:no_results) %>
  </div>
<% end %>

<%= paginate @favorite_products %>

app/views/spree/admin/favorite_products/users.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:listing_favorite_products_users) %>
<% end %>

<%= paginate @users %>

<% if @users.any? %>
  <table class="index" id="listing_favorite_products_users">
    <thead>
      <tr data-hook="admin_products_index_headers">
        <th>Email</th>
      </tr>
    </thead>
    <tbody>
      <% @users.each do |user| %>
        <tr>
          <td>
            <%= user.email %>
          </tr>
      <% end %>
    </tbody>
  </table>
<% else %>
  <div class="no-objects-found">
    <%= Spree.t(:no_results) %>
  </div>
<% end %>

<%= paginate @users %>

app/views/spree/admin/favorite_variants/index.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:listing_favorite_variants) %>
<% end %>

<%= paginate @favorite_variants %>

<% if @favorite_variants.any? %>
  <table class="table table-striped" id="listing_products">
    <thead>
      <tr data-hook="admin_products_index_headers">
        <th><%= Spree.t(:sku) %></th>
        <th><%= Spree.t(:image) %></th>
        <th><%= sort_link @search, :product_name, Spree.t(:name) %></th>
        <th class="text-right"><%= sort_link @search, 'favorite_users_count', Spree.t(:favorite_users) %></th>
      </tr>
    </thead>
    <tbody>
      <% @favorite_variants.each do |variant| %>
          <tr data-hook="admin_products_index_rows">
            <td ><%= variant.sku rescue '' %></td>
            <td ><%= mini_image(variant) %></td>
            <td><%= link_to variant.product.try(:name), edit_admin_product_variant_path(variant.product, variant) %></td>
            <td class="text-right">
              <%= link_to variant.favorite_users.count, users_admin_favorite_product_path(id: variant.product.id, item_id: variant.id, type: 'variant') %>
            </td>
          </tr>
      <% end %>
    </tbody>
  </table>
<% else %>
  <div class="no-objects-found">
    <%= Spree.t(:no_results) %>
  </div>
<% end %>

<%= paginate @favorite_variants %>

app/views/spree/admin/products/favorite_users.html.erb
<% content_for :page_actions do %>
  <% if can?(:create, Spree::Product) %>
    <%= button_link_to Spree.t(:new_product), new_object_url, { class: "btn-success", icon: 'add', id: 'admin_new_product' } %>
  <% end %>
<% end %>

<%= render partial: 'spree/admin/shared/product_tabs', locals: { current: :favorited_by } %>

<%= render 'spree/admin/favorite_products/users' %>

app/views/spree/admin/users/favorite_products.html.erb
<%= render partial: 'spree/admin/users/sidebar', locals: { current: :favorite_products } %>
<%= render partial: 'spree/admin/users/user_page_actions' %>

<% content_for :page_title do %>
  <%= @user.email %>
<% end %>

<div data-hook="admin_user_edit_general_settings" class="panel panel-default">
  <div class="panel-heading">
    <h1 class="panel-title">
      <%= Spree.t(:favorite_product) %>
    </h1>
  </div>

  <div class="panel-body">
    <div data-hook="account_my_favorite_products" class="account-my-favorite-products commonform">
      <h3><%= Spree.t(:favorite_products, scope: [:admin, :tab]) %></h3>
      <% if @favorite_products.empty? && @favorite_variants.empty? %>
        <p><%= Spree.t(:you_have_no_favorite_products_yet) %></p>
      <% else %>
        <table class="favorite-products order-summary table table-striped" width="100%">
          <thead>
          <tr>
            <th class="favorite-product-image"><%= Spree.t(:product_image) %></th>
            <th class="favorite-product-name"><%= Spree.t(:product_name) %></th>
            <th class="favorite-product-sku"><%= Spree.t(:sku) %></th>
            <th class="favorite-product-action actions"></th>
          </tr>
          </thead>
          <tbody>
          <% @favorite_products.each do |product| %>
            <tr class="<%= cycle('even', 'odd') %> favorite_product" id="favorite_product_<%= product.id %>">
              <td class="favorite-product-image"><%= link_to admin_product_path(product) do %>
                <%= mini_image product %>
                <% end %>
              </td>
              <td class="favorite-product-name"><%=link_to product.name, admin_product_path(product) %></td>
              <td class="favorite-product-sku"><%=link_to product.sku, admin_product_path(product) %></td>
              <td class="favorite-product-remove actions text-right">
                <%= link_to_edit product, no_text: true, url: admin_product_path(product) %>
                <%= link_to_delete product, no_text: true, url: admin_favorite_product_path(id: product.favorites.where(user_id: @user.id).first) %>
            </tr>
          <% end %>

          <% @favorite_variants.each do |variant| %>
          <tr class="<%= cycle('even', 'odd') %> favorite_product" id="favorite_product_<%= variant.id %>">
            <td class="favorite-product-image"><%= link_to admin_product_path(variant.product) do %>
              <%= mini_image variant %>
              <% end %>
            </td>
            <td class="favorite-product-name"><%=link_to variant.product.name, admin_product_path(variant.product) %></td>
            <td class="favorite-product-sku"><%=link_to variant.sku, admin_product_path(variant.product) %></td>
            <td class="favorite-product-remove actions text-right">
              <%= link_to_edit variant, no_text: true, url: edit_admin_product_variant_path(variant.product, variant) %>
              <%= link_to_delete variant, no_text: true, url: admin_favorite_product_path(id: variant.favorites.where(user_id: @user.id).first) %>
          </tr>
          <% end %>
          </tbody>
        </table>
      <% end %>
    </div>
  </div>
</div>

app/views/spree/favorite_products/_cart_form.html.erb
<%= form_for :order, url: populate_orders_path do |f| %>
  <div class="row" id="inside-product-cart-form" data-hook="inside_product_cart_form" itemprop="offers" itemscope itemtype="https://schema.org/Offer">
    <% if type == "product" %>
      <%= hidden_field_tag "variant_id", item.master.id %>
    <% else %>
      <%= hidden_field_tag "variant_id", item.id %>
    <% end %>

    <% if item.price_in(current_currency) && !item.price.nil? %>
      <div data-hook="product_price" class="col-md-5">
        <div id="product-price">
          <h6 class="product-section-title"><%= Spree.t(:price) %></h6>
          <div>
            <span class="lead price selling" itemprop="price" content="<%= item.price_in(current_currency).amount.to_d %>">
              <%= display_price(item) %>
            </span>
            <span itemprop="priceCurrency" content="<%= current_currency %>"></span>
          </div>

          <% if (type == "product" && item.master.can_supply?) || ((type == "variant" && item.can_supply?)) %>
            <link itemprop="availability" href="https://schema.org/InStock" />
          <% else %>
            <span class="out-of-stock"><%= Spree.t(:out_of_stock) %></span>
          <% end %>
        </div>

        <% if item.can_supply? %>
          <div class="add-to-cart">
            <br />
            <div class="input-group">
              <%= hidden_field_tag :quantity, 1 %>
              <span class="input-group-btn">
                <%= button_tag class: 'btn btn-success', id: 'add-to-cart-button', type: :submit do %>
                  <%= Spree.t(:add_to_cart) %>
                <% end %>
              </span>
            </div>
          </div>
        <% end %>
      </div>
    <% else %>
      <div id="product-price">
        <br />
        <div>
          <span class="price selling" itemprop="price">
            <%= Spree.t('product_not_available_in_this_currency') %>
          </span>
        </div>
      </div>
    <% end %>
  </div>
<% end %>

app/views/spree/favorite_products/create.js.erb
<% if @success %>
  $('.favorite_link').attr('href', '<%= favorite_product_path(id: params[:id], type: params[:type]) %>').attr('id', 'unmark_as_favorite').data('method', 'delete').text('<%= Spree.t(:unmark_as_favorite) %>')

  var $item = $("#favorite_variant_<%= params[:id]%>"),
      $removeFromCart = $item.closest('tr').find('a.delete');

  $item.remove();
  $removeFromCart.click(); // remove it from cart
<% end %>
alert("<%=j @message%>");

app/views/spree/favorite_products/destroy.js.erb
<% if @success %>
  if($('.favorite_link').length) {
    $('.favorite_link').attr('href', '<%= favorite_products_path(:id => params[:id], type: params[:type]) %>').attr('id', 'mark_as_favorite').data('method', 'post').text('<%= Spree.t(:mark_as_favorite) %>')
    alert('Successfully unmarked as favorite');
  } else {
    <% if @favorite.favoritable_type == 'Spree::Product' %>
      $("#favorite_product_<%= @favorite.favoritable_id%>").remove();
    <% else %>
      $("#favorite_variant_<%= @favorite.favoritable_id%>").remove();
    <% end %>
    alert("Successfully removed favorite product from your list");
    if (!$('.favorite_product').length) {
      window.location = '<%= favorite_products_path %>'
    }
  }
<% else %>
  alert("Could not remove product form your list")
<% end %>

app/views/spree/favorite_products/get_favoritable_value.js.erb
<% if @favorite %>
  $('.favorite_link').attr('href', '<%= favorite_product_path(id: params[:id], type: params[:type]) %>').attr('id', 'unmark-as-favorite').data('method', 'delete').text('<%= Spree.t(:unmark_as_favorite) %>')
<% else %>
  $('.favorite_link').attr('href', '<%= favorite_products_path(id: params[:id], type: params[:type]) %>').attr('id', 'mark-as-favorite').data('method', 'post').text('<%= Spree.t(:mark_as_favorite) %>')
<% end %>

app/views/spree/favorite_products/index.html.erb
<div data-hook="account_my_favorite_products" class="account-my-favorite-products commonform">
  <h3><%= Spree.t(:my_favorite_products) %></h3>
  <% if @favorite_products.empty? && @favorite_variants.empty? %>
    <p><%= Spree.t(:you_have_no_favorite_products_yet) %></p>
  <% else %>
    <table class="favorite-products order-summary table table-striped" width="100%">
      <thead>
      <tr>
        <th class="favorite-product-image"><%= Spree.t(:product_image) %></th>
        <th class="favorite-product-name"><%= Spree.t(:product_name) %></th>
        <th> </th>
        <th class="favorite-product-action text-right"><%= Spree.t(:action) %></th>
      </tr>
      </thead>
      <tbody>
      <% @favorite_products.each do |product| %>
        <tr class="<%= cycle('even', 'odd') %> favorite_product" id="favorite_product_<%= product.id %>">
          <td class="favorite-product-image"><%= link_to mini_image(product), product_path(product) %></td>
          <td class="favorite-product-name"><%= product.name %></td>
          <td>
            <% if product.variants.any? %>
              <%= link_to 'See All Buying Options', product_path(product), class: 'btn btn-success' %>
            <% else %>
              <%= render partial: 'cart_form', locals: { item: product, type: 'product' } %>
            <% end %>
          </td>
          <td class="favorite-product-remove text-right"><%= link_to Spree.t(:remove), favorite_product_path(id: product.id, type: 'Spree::Product'), method: :delete, remote: true, confirm: 'Are you sure you want to remove the product?' %>
        </tr>
      <% end %>

      <% @favorite_variants.each do |variant| %>
        <tr class="<%= cycle('even', 'odd') %> favorite_product" id="favorite_variant_<%= variant.id %>">
          <td class="favorite-product-image"><%= link_to mini_image(variant), product_path(variant.product) %></td>
          <td class="favorite-product-name">
            <%= variant.product.name %>
            <br/>
            <%= variant_options variant %>
          </td>
          <td> <%= render partial: 'cart_form', locals: { item: variant, type: 'variant' } %> </td>
          <td class="favorite-product-remove text-right"><%= link_to Spree.t(:remove), favorite_product_path(id: variant.id, type: 'Spree::Variant'), method: :delete, remote: true, confirm: 'Are you sure you want to remove the product?' %>
        </tr>
      <% end %>
      </tbody>
    </table>
  <% end %>
</div>

app/views/spree/favorite_products/not_found.js.erb
alert("<%= Spree.t(:product_not_found) %>");